 ; ADF4351 by F5UBZ
 #include "p12f675.inc" 

 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _BOREN_ON & _CP_OFF & _CPD_OFF
 
 ; EEPROM LOCATION 
 
 		ORG	0x2100
		
		; GPIO4 a la masse GPIO5 a la masse
		DE	0x00, 0xC4, 0x00, 0x50  ; register  R0  1960.5 Mhz ref 10Mhz 
		DE	0x08, 0x00, 0x83, 0x21  ; register  R1  tx 439.790 mhz
		DE	0x78, 0x00, 0x5E, 0x42  ; register  R2  = 10789.790 sortie Qo100
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3  low spur pwr 5dm
		DE	0x00, 0x95, 0x02, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5 			
		
		;GPIO4 a la masse GPIO5 en l'air 
		DE	0x00, 0x78, 0x00, 0x00  ; register  R0  300 Mhz ref 10Mhz//low noise mode
		DE	0x08, 0x00, 0x80, 0x11  ; register  R1  
		DE	0x18, 0x00, 0x5E, 0x42  ; register  R2  pwr 5dm
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3 739.790 - 300 = 439.790 Mhz
		DE	0x00, 0xB5, 0x02, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5 		
				
			
		; GPIO4 en l'air GPIO5 a la masse		
		DE	0x00, 0x70, 0x80, 0x58  ; register  R0  2255.5 Mhz ref 10Mhz 
		DE	0x08, 0x00, 0x80, 0xA1  ; register  R1  tx 144.790 mhz
		DE	0x18, 0x00, 0x5E, 0x42  ; register  R2  = 10789.790 sortie Qo100
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3 
		DE	0x00, 0x85, 0x02, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5 				
		
		
		; GPIO4 en l'air et GPIO5 en l'air
		DE	0x00, 0x77, 0x00, 0x00  ; register  R0  595 Mhz ref 10Mhz//low noise mode
		DE	0x08, 0x00, 0x80, 0x11  ; register  R1  
		DE	0x18, 0x00, 0x5E, 0x42  ; register  R2  pwr 5dm
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3 739.790 - 595 = 144.790 Mhz
		DE	0x00, 0xA5, 0x02, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5 	
		
	

ADF4351_data	 equ	0x00 	  
ADF4351_LD       equ    0x03 
ADF4351_clk      equ	0x01 
ADF4351_data	 equ	0x00 	
ADF4351_LE       equ    0x02 

cnt	           equ 40h   ;
count              equ 41h   ;
temp               equ 42h   ;
	       
register_db31_db24 equ 43h   ;
register_db23_db16 equ 44h   ;
register_db15_db8  equ 45h   ;
register_db7_db0   equ 46h   ; 
reg_out            equ 47h   ;
W_TEMP             equ 48h   ;
STATUS_TEMP        equ 49h   ;	     
flag_flip_flop     equ 4Ah   ; 

	 

                org 0
		goto start 	
		
		 
		
start           bcf STATUS,RP0
		clrf GPIO		
		bsf STATUS,RP0
		movlw b'0000000'   
		movwf ANSEL        
		movlw b'00111000'  
		movwf TRISIO       
		movlw b'00110000'
		movwf WPU
		movlw b'01111111'
		movwf OPTION_REG
		bcf STATUS,RP0
		movlw d'7'
		movwf CMCON  			
		bcf GPIO,ADF4351_clk 	
		bcf GPIO,ADF4351_data
		bcf GPIO,ADF4351_LE
		bsf GPIO,ADF4351_LE
		bcf GPIO,ADF4351_LE
		
		movlw d'200'
		movwf cnt
delai		call wait_2ms
	        decfsz cnt,f
		goto delai          ;0.4 s approx 
		
			
	
		
		
		clrf flag_flip_flop
		
		
		
				
;*********** Main_loop********************
main_loop	btfsc GPIO,GP4
		goto $+4
		btfsc GPIO,GP5
		goto preset_f2
		goto preset_f1		
		btfss GPIO,GP5
		goto preset_f3
		goto preset_f4
		goto main_loop
;******************************************	
		
preset_f1       btfsc flag_flip_flop,1
		goto main_loop
		movlw d'20'		
         	call eeprom_read
		movwf register_db31_db24
		movlw d'21'
		call eeprom_read
		movwf register_db23_db16
		movlw d'22'
		call eeprom_read
		movwf register_db15_db8
		movlw d'23'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'16'
		call eeprom_read
		movwf register_db31_db24
		movlw d'17'
		call eeprom_read
		movwf register_db23_db16
		movlw d'18'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'19'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'12'
		call eeprom_read
		movwf register_db31_db24
		movlw d'13'
		call eeprom_read
		movwf register_db23_db16
		movlw d'14'
		call eeprom_read
		movwf register_db15_db8
		movlw d'15'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'8'
		call eeprom_read
		movwf register_db31_db24
		movlw d'9'
		call eeprom_read
		movwf register_db23_db16
		movlw d'10'
		call eeprom_read
		movwf register_db15_db8
		movlw d'11'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'4'
		call eeprom_read
		movwf register_db31_db24
		movlw d'5'
		call eeprom_read
		movwf register_db23_db16
		movlw d'6'
		call eeprom_read
		movwf register_db15_db8
		movlw d'7'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'0'
		call eeprom_read
		movwf register_db31_db24
		movlw d'1'
		call eeprom_read
		movwf register_db23_db16
		movlw d'2'
		call eeprom_read
		movwf register_db15_db8
		movlw d'3'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms
		call wait_2ms
		call wait_2ms
		call wait_2ms
		bsf flag_flip_flop,1
		bcf flag_flip_flop,2
		bcf flag_flip_flop,3
		bcf flag_flip_flop,4		
		goto main_loop	
		
preset_f2	btfsc flag_flip_flop,2
		goto main_loop
		movlw d'44'		
		call eeprom_read
		movwf register_db31_db24
		movlw d'45'
		call eeprom_read
		movwf register_db23_db16
		movlw d'46'
		call eeprom_read
		movwf register_db15_db8
		movlw d'47'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'40'
		call eeprom_read
		movwf register_db31_db24
		movlw d'41'
		call eeprom_read
		movwf register_db23_db16
		movlw d'42'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'43'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'36'
		call eeprom_read
		movwf register_db31_db24
		movlw d'37'
		call eeprom_read
		movwf register_db23_db16
		movlw d'38'
		call eeprom_read
		movwf register_db15_db8
		movlw d'39'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'32'
		call eeprom_read
		movwf register_db31_db24
		movlw d'33'
		call eeprom_read
		movwf register_db23_db16
		movlw d'34'
		call eeprom_read
		movwf register_db15_db8
		movlw d'35'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'28'
		call eeprom_read
		movwf register_db31_db24
		movlw d'29'
		call eeprom_read
		movwf register_db23_db16
		movlw d'30'
		call eeprom_read
		movwf register_db15_db8
		movlw d'31'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'24'
		call eeprom_read
		movwf register_db31_db24
		movlw d'25'
		call eeprom_read
		movwf register_db23_db16
		movlw d'26'
		call eeprom_read
		movwf register_db15_db8
		movlw d'27'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms	
		call wait_2ms
		call wait_2ms
		call wait_2ms
		bsf flag_flip_flop,2
		bcf flag_flip_flop,1
		bcf flag_flip_flop,3
		bcf flag_flip_flop,4
		goto main_loop
				
preset_f3	btfsc flag_flip_flop,3
		goto main_loop
		movlw d'68'		
		call eeprom_read
		movwf register_db31_db24
		movlw d'69'
		call eeprom_read
		movwf register_db23_db16
		movlw d'70'
		call eeprom_read
		movwf register_db15_db8
		movlw d'71'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'64'
		call eeprom_read
		movwf register_db31_db24
		movlw d'65'
		call eeprom_read
		movwf register_db23_db16
		movlw d'66'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'67'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'60'
		call eeprom_read
		movwf register_db31_db24
		movlw d'61'
		call eeprom_read
		movwf register_db23_db16
		movlw d'62'
		call eeprom_read
		movwf register_db15_db8
		movlw d'63'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'56'
		call eeprom_read
		movwf register_db31_db24
		movlw d'57'
		call eeprom_read
		movwf register_db23_db16
		movlw d'58'
		call eeprom_read
		movwf register_db15_db8
		movlw d'59'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'52'
		call eeprom_read
		movwf register_db31_db24
		movlw d'53'
		call eeprom_read
		movwf register_db23_db16
		movlw d'54'
		call eeprom_read
		movwf register_db15_db8
		movlw d'55'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'48'
		call eeprom_read
		movwf register_db31_db24
		movlw d'49'
		call eeprom_read
		movwf register_db23_db16
		movlw d'50'
		call eeprom_read
		movwf register_db15_db8
		movlw d'51'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms	
		call wait_2ms
		call wait_2ms
		call wait_2ms
		bsf flag_flip_flop,3
		bcf flag_flip_flop,1
		bcf flag_flip_flop,2
		bcf flag_flip_flop,4				
		goto main_loop	
		
preset_f4	btfsc flag_flip_flop,4
		goto main_loop
		movlw d'92'		
		call eeprom_read
		movwf register_db31_db24
		movlw d'93'
		call eeprom_read
		movwf register_db23_db16
		movlw d'94'
		call eeprom_read
		movwf register_db15_db8
		movlw d'95'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'88'
		call eeprom_read
		movwf register_db31_db24
		movlw d'89'
		call eeprom_read
		movwf register_db23_db16
		movlw d'90'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'91'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'84'
		call eeprom_read
		movwf register_db31_db24
		movlw d'85'
		call eeprom_read
		movwf register_db23_db16
		movlw d'86'
		call eeprom_read
		movwf register_db15_db8
		movlw d'87'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'80'
		call eeprom_read
		movwf register_db31_db24
		movlw d'81'
		call eeprom_read
		movwf register_db23_db16
		movlw d'82'
		call eeprom_read
		movwf register_db15_db8
		movlw d'83'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'76'
		call eeprom_read
		movwf register_db31_db24
		movlw d'77'
		call eeprom_read
		movwf register_db23_db16
		movlw d'78'
		call eeprom_read
		movwf register_db15_db8
		movlw d'79'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'72'
		call eeprom_read
		movwf register_db31_db24
		movlw d'73'
		call eeprom_read
		movwf register_db23_db16
		movlw d'74'
		call eeprom_read
		movwf register_db15_db8
		movlw d'75'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms	
		call wait_2ms
		call wait_2ms
		call wait_2ms
		bsf flag_flip_flop,4
		bcf flag_flip_flop,1
		bcf flag_flip_flop,2
		bcf flag_flip_flop,3
		goto main_loop


		
eeprom_read  	bsf STATUS,RP0
		movwf EEADR
		bsf EECON1,RD
		movf EEDATA,W
		bcf STATUS,RP0
                return			
	

output_register  movf register_db31_db24,0
		 movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk			   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   	   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   	   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db23_db16,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk	 		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	  
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db15_db8,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk	   		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db7_db0,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk			   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		bsf GPIO,ADF4351_LE 
		bcf GPIO,ADF4351_LE 
		return
			
			
wait_2ms        movlw	D'4'	 
                movwf   count    
outer_loop                        
	        movlw	H'A4'		
	        movwf	temp
inner_loop
	        decfsz	temp,f		
	        goto	inner_loop				
	        decfsz	count,f		
	        goto	outer_loop				
	        return			

		
		END
		